PPTEXT = """
;; CPMG scheme wit 1H decoupling (odd numer of cycles 
;; can be used in both sides of CPMG CT delay
;; protCW should be calculated as 2k*v_cpmg where k is integer
;; (use protCW around 12 kHz if possible)
;; v4 modified by theok to be ready for automatic setup 

#include <Avance.incl>
#include <Grad.incl>

;$EXTERN 

#define TEMPCOMP				; comment if not needed

define delay TIME_T2
"TIME_T2 = d24"

define delay DEL
define delay DEL_1

define delay TAUB
"TAUB=2.68m-p25-2u"

define delay TAUB_2
"TAUB_2=2.68m-p27-2u"

define delay TAUB_3
"TAUB_3=2.68m-p28-2u"

define delay TAU_EQ
"TAU_EQ=4m-p24*1.5-32u"

define delay TAU_EQ1
"TAU_EQ1=4m-p26-32u"

define delay CHI_1
"CHI_1=1/(2*3.1416*10000)" ;use 11kHz 1H cw if possible
define delay CHI
"CHI=CHI_1-(1.2732*p1)"  		; modify according to 1H SL power

define delay ZETA
"ZETA=p7-0.63662*p1+4u"

define delay ZETA_1
"ZETA_1=10u-0.63662*p1"

define delay COMPH
"COMPH=larger(p1*2, p4*2)+d0*2"

define delay bigT
"bigT=500u"

define delay bigT_1
"bigT_1=500u-p29-4u+p1*0.63662-de"

"d3=2.68m-p23-2u"

"d11=1m"
"d12=1m"

;calculate offset for the ca pulse
"cnst21=176"
"cnst22=56"
"spoff4=bf2*((cnst22-cnst21)/1000000)"

"spw2=plw1*(pow((p1/p2)/0.067094,2))" ;Eburp pulse power
define pulse Cpulse  ;define calibrated 13C pulse for power determ only
"Cpulse=p22"
"spw4=plw2*(pow((Cpulse/p4),2))"  ;ca pulse power
"spw5=spw4"                       ;co pulse power


;N15 INITIAL EVOLUTION DELAY
"d0=2u"

"l3=td2/2"
"l2=td1"
"in0=inf2/2"

;define list<power> protCW = {dB  -1.4 -1.4} 


define loopcounter COUNTER
define list<loopcounter> ncyc=<$VCLIST> 
;for testing
;define list<loopcounter> ncyc = {0 4}

;;define loopcounter ncyc 							
;;"ncyc=l0"
;;"ncyc=2"

; set the frequency to amide region (ppm)
"cnst19=8.5"



1 ze 
2 2u do:f3
3 2u do:f3
4 2u do:f3
5 2u do:f3
  1m BLKGRAD
  
#ifdef TEMPCOMP

  if "ncyc == 0"
{
  2u pl0:f1
  (p2:sp2 ph11:r):f1
  2u protCW:f1
  ;2u cw:f1 ph0
  2u cpd1:f1
  TIME_T2 
  2u do:f1    
  2u pl0:f1
  (p2:sp2 ph10:r):f1
}

#endif
  
  d1

if "ncyc == 0"
  {
   "DEL = TIME_T2/4 - p7"
   "DEL_1 = DEL - p7*0.63662"
   "COUNTER = 0"
  }
else
  {
   "DEL = TIME_T2/(4*ncyc) - p7"
   "DEL_1 = TIME_T2/(4*ncyc) - p7*0.63662"
   "COUNTER = ncyc - 1"
  }

  1m UNBLKGRAD
  10u pl7:f3
  (p7 ph0):f3
  2u 
  p20:gp0
  1m
  2u pl0:f1
  (p2:sp2 ph10:r):f1  
  2u pl1:f1
 
  (p1 ph0):f1
  2u
  p23:gp3
  d3
  (center (p7*2 ph0):f3 (p1*2 ph0):f1)
  2u
  p23:gp3
  d3
  (p1 ph11):f1
   
  2u
  p24:gp4*-1
  300u
   
;******	CONVERT TO IN-PHASE **************
  (p7 ph0):f3
  2u
  p25:gp5
  TAUB
  (center (p7*2 ph0):f3 (p1*2 ph0):f1)
  2u
  p25:gp5
  TAUB
  (lalign (p7 ph11):f3 (p1*2 ph0):f1)
;******************************************   
  2u
  p24*1.1:gp4
  TAU_EQ   
  30u fq=cnst19(bf ppm):f1
   
  (p1 ph6):f1
  CHI
  (p1 ph0):f1
  ZETA
  (p1*2 ph6):f1
  4u protCW:f1




  
  (p7 ph2):f3   
;********* CPMG STARTS HERE **************
if "ncyc > 0"
{  
   ;DEL_1 cw:f1 ph0
   DEL_1 cpd1:f1
   (p7*2 ph5):f3
   DEL
}

if "ncyc > 1"
{  
10 DEL
   (p7*2 ph5):f3
   DEL 
lo to 10 times COUNTER
}
;*******************************************

   2u
   2u do:f1
   2u pl1:f1
   (center (p7*2 ph12):f3 (p1*2 ph0):f1)
   2u 
   2u protCW:f1
   ;2u cw:f1 ph0
   2u cpd1:f1

;******	CPMG CONTINUES HERE ***************
if "ncyc > 1"
{  
20 DEL
   (p7*2 ph5):f3
   DEL
lo to 20 times COUNTER
}

if "ncyc > 0"
{  
   DEL
   (p7*2 ph5):f3
   DEL_1
}
;******** CPMG ENDS HERE ******************
   (p7 ph0):f3





   5u do:f1
   5u pl1:f1
   (p1*2 ph7):f1
   ZETA_1
   (p1 ph0):f1
   CHI
   (p1 ph7):f1
   
      
   2u
   p26:gp6   
   30u fq=0:f1
   TAU_EQ1
   
;********** N15 evolution **************
   (p7 ph3):f3  
   d0
   2u
   p27:gp7
   TAUB_2 pl4:f2	
   (center (p1*2 ph0):f1 (p4*2:sp5 ph0 3u 3u pl4 p4*2:sp4):f2)
   d0
   (p7*2 ph0):f3
   2u
   p27:gp7*-1
   TAUB_2
   COMPH

;   (p7 ph3):f3
;   d0*0.5 gron11
;   2u groff
;   d0*0.5 gron11*-1  
;   2u groff
;   p27:gp7
;   TAUB_2
;   (p1*2 ph0):f1
;   d0*0.5 gron11
;   2u groff
;   d0*0.5 gron11*-1  
;   2u groff
;   (p7*2 ph0):f3
;   8u
;   p27:gp7*-1
;   TAUB_2
;   COMPH
;****** back to protons ****************

   (center (p7 ph8):f3 (p1 ph9):f1)
   2u
   p28:gp8
   TAUB_3
   (center (p7*2 ph0):f3 (p1*2 ph0):f1)
   2u
   p28:gp8
   TAUB_3
   (center (p7 ph11):f3 (p1 ph11):f1)
   2u
   p28:gp8
   TAUB_3
   (center (p7*2 ph0):f3 (p1*2 ph0):f1)
   2u
   p28:gp8
   TAUB_3
   (p1 ph0):f1
   
   bigT
   (p1*2 ph0):f1
   2u
   p29:gp9*EA
   bigT_1
   2u pl31:f3

   go=2 ph31 cpd3:f3
   10u do:f3
   d11 wr #0 if #0 zd

   d12 ncyc.inc
   d12 protCW.inc
   lo to 3 times l2

   d12 ip8*2
   d12 igrad EA
   lo to 4 times 2

   d12 ip3
   d12 ip3
   d12 ip31
   d12 ip31    
   d12 id0
   lo to 5 times l3

1m do:f3
exit 



ph0=0
ph2=0 2
;ph3=1 1 3 3		      ;uncomment for 4-step cycle
ph3=1 1 1 1 3 3 3 3	      ;uncomment for 8-step cycle     ;3 3 3 3 1 1 1 1  
ph4=0
ph5=1			      ;3
ph6=1 1 3 3		      ;3 3 1 1
ph7=3 3 1 1                   ;1 1 3 3
ph8=0
ph9=2
ph10=3				;1
ph11=1				;3
ph12=0 0 2 2
;ph31=0 2 2 0                  ;uncomment for 4-step cycle
ph31=0 2 0 2 2 0 2 0	      ;uncomment for 8-step cycle


;d24 : timeT2
"""
import math
import sys


ncyc_list  = GETPAR("VCLIST") #name of the vclist
timeT2     = float(GETPAR("D 24")) #stupid space!
pw_h       = float(GETPAR("P 1"))
H_POWER_db = GETPAR("PLdB 1") #capitals!

ncyc=[]
f = open("/opt/topspin3.2pl7/exp/stan/nmr/lists/vc/%s"%ncyc_list , 'r')
lines=f.readlines()
f.close()
for line in lines:
    line.strip()
    fields=line.split()
    ncyc.append(int(fields[0]))

CW_NOMINAL_POWER = 10000 # put to11kHz if possible add as constant
H_POWER_db=float(H_POWER_db)
protCW=[]
for n in ncyc:
    if n == 0:
        n=1
    NU_CPMG = n/timeT2
    
    if NU_CPMG> 1000.:
       MSG("CPMG frequency too large! n = %i" %n)
       EXIT()
    CW_POWER = (round(CW_NOMINAL_POWER/(2.*NU_CPMG)))*2.*NU_CPMG
    CW_POWER_PULSE = (1e+6/4.)/CW_POWER
    CW_POWER_DB = H_POWER_db + 20.*math.log10(CW_POWER_PULSE/pw_h)
    protCW.append(round(CW_POWER_DB,2) )
# 


index=PPTEXT.index(';$EXTERN')
cw='define list<power> protCW = {dB '+ ' '.join(str(i) for i in protCW) + '}'
PPTEXT=PPTEXT[:index]+ cw+ "\n" +PPTEXT[index:]
pp = DEF_PULSPROG(PPTEXT)


ppName = "auto_cpmg.ppy"
PUTPAR("PULPROG", ppName)

pp.SAVE_AS(ppName)
#ZG()