"""

short gui for theos pulse sequences

created by:
    theok 17.10.2020

"""
from javax.swing import *
from java.awt import *
import os 
import de.bruker.nmr.mfw.root.UtilPath as Path
from javax.imageio import ImageIO
from zipfile import ZipFile
from java.io import ByteArrayInputStream
#/Users/fbstka/Documents/Spectra/


class TheosGUI(): 
    #def __init__(self):
    #    icoPath = os.path.join(Path.getTopspinHome(), "exp", "stan", "nmr", "lists","relax", "relax.png")
    #    self.ico = ImageIO.read(file(icoPath))

        
  
    def createGUI(self):
        self.frame = JFrame('TopSpin / Theos GUI') # create window with title
        self.frame.setSize(400, 400) # set window size x, y
        self.frame.setLayout(FlowLayout()) # layout manager for horizontal alignment
        self.frame.setLocationRelativeTo(None)
        label = JLabel("Welcome to Leeds Pulse Sequence Library")
        button1 = JButton('15NT1rho', actionPerformed = self.__new_T1rho_exp)
        button2 = JButton('15NT1', actionPerformed = self.__new_T1_exp)
        button3 = JButton('15NCPMG', actionPerformed = self.__new_CPMG_exp)
        #button4 = JButton('15NCPMG_2D', actionPerformed = None)
        #self.frame.add(label)
        self.frame.add(button1)
        self.frame.add(button2)
        self.frame.add(button3)
        #self.frame.add(button4)
        
        self.frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE)
       # self.frame.setIconImage(self.ico)
        
        self.frame.setVisible(True)

    def __new_T1rho_exp(self, event):
        result = DATASET_DIALOG("MyTitle", )
        name, expno, procno, dir=result[0], int(result[1]), int(result[2]), result[3]  
        ct=EXEC_PYSCRIPT('NEWDATASET(["%s" , "%i", "%i", "%s"], None, "T1rhoN15_rk_v2")' %(name, expno, procno, dir))
        ct.join() # wait until new dataset is created before RE
        EXEC_PYSCRIPT('RE(["%s" , "%i", "%i", "%s"])' %(name, expno, procno, dir))
        EXEC_PYSCRIPT('MSG(" New T1rho experiment. Check Hard Powel Levels !! ")')
        self.frame.dispose()
        
    def __new_T1_exp(self, event):
        result = DATASET_DIALOG("MyTitle", )
        name, expno, procno, dir=result[0], int(result[1]), int(result[2]), result[3]  
        ct=EXEC_PYSCRIPT('NEWDATASET(["%s" , "%i", "%i", "%s"], None, "T1N15_rk_v2")' %(name, expno, procno, dir))
        ct.join() # wait until new dataset is created before RE
        EXEC_PYSCRIPT('RE(["%s" , "%i", "%i", "%s"])' %(name, expno, procno, dir))
        EXEC_PYSCRIPT('MSG(" New T1 experiment. Check Hard Powel Levels !! ")')
        self.frame.dispose()
     
    def __new_CPMG_exp(self, event):
        result = DATASET_DIALOG("MyTitle", )
        name, expno, procno, dir=result[0], int(result[1]), int(result[2]), result[3]  
        ct=EXEC_PYSCRIPT('NEWDATASET(["%s" , "%i", "%i", "%s"], None, "N15_CPMG_INPHASE_GSEL_v4")' %(name, expno, procno, dir))
        ct.join() # wait until new dataset is created before RE
        EXEC_PYSCRIPT('RE(["%s" , "%i", "%i", "%s"])' %(name, expno, procno, dir))
        #ct=EXEC_PYFILE('cpmg.py')
        #ct.join()
        EXEC_PYSCRIPT('MSG(" After setting up d24 (relax delay), P1 and vclist type cpmg.py ")')
        EXEC_PYSCRIPT('MSG(" New CPMG experiment. Check Hard Powel Levels !! ")')
        self.frame.dispose()
        

sel=TheosGUI()
sel.createGUI()
